﻿Imports Infragistics.Win

Public Class Form1

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles Me.Load
        Me.BuildMinimalIGExampleGantt()
    End Sub

    Private Sub BuildMinimalIGExampleGantt()

        'Working IG Version using datatable:

        Dim ds As DataSet = Me.GetSampleData()

        ' Set the BindingContextControl property to reference this form 
        Me.UltraCalendarInfo1.DataBindingsForTasks.BindingContextControl = Me

        'Set the DataBinding members for Tasks
        Me.UltraCalendarInfo1.DataBindingsForTasks.DataSource = ds
        Me.UltraCalendarInfo1.DataBindingsForTasks.DataMember = "Tasks"

        Me.UltraCalendarInfo1.MinDate = New Date(2012, 1, 1)
        Me.UltraCalendarInfo1.MaxDate = New Date(2015, 1, 1)

        ' Basic Task properties 
        Me.UltraCalendarInfo1.DataBindingsForTasks.NameMember = "TaskName"
        Me.UltraCalendarInfo1.DataBindingsForTasks.DurationMember = "TaskDuration"
        Me.UltraCalendarInfo1.DataBindingsForTasks.StartDateTimeMember = "TaskStartTime"
        Me.UltraCalendarInfo1.DataBindingsForTasks.IdMember = "TaskID"
        Me.UltraCalendarInfo1.DataBindingsForTasks.ParentTaskIdMember = "ParentTaskID"
        Me.UltraCalendarInfo1.DataBindingsForTasks.ConstraintMember = "Constraint"
        'Me.UltraCalendarInfo1.DataBindingsForTasks.PercentCompleteMember = "TaskPercentComplete"

        Me.UltraGanttView1.CalendarInfo = Me.UltraCalendarInfo1

        'task with image background
        Dim imageTask = Me.UltraCalendarInfo1.Tasks(0).Tasks(1)
        imageTask.PercentComplete = 50


        Dim flag As New Bitmap(1000, 50)
        Dim flagGraphics As Graphics = Graphics.FromImage(flag)

        flagGraphics.FillRectangle(New SolidBrush(Color.Red), New Rectangle(0, 0, 1000, 50))

        'imageTask.TimelineSettings.BarSettings.BarAppearance.ImageBackground = flag
        'imageTask.TimelineSettings.BarSettings.BarAppearance.ImageBackgroundStyle = ImageBackgroundStyle.Stretched
    End Sub

    Private Function GetSampleData() As DataSet

        Dim theDataSet As New DataSet()

        Dim theTasks As DataTable = theDataSet.Tables.Add("Tasks")
        theTasks.Columns.Add("TaskID")
        theTasks.Columns.Add("TaskName")
        theTasks.Columns.Add("TaskStartTime", GetType(DateTime))
        theTasks.Columns.Add("TaskDuration", GetType(TimeSpan))
        theTasks.Columns.Add("ParentTaskID")
        theTasks.Columns.Add("Constraint", GetType(Integer))
        theTasks.Columns.Add("TaskPercentComplete")
        '    'The Task properties are all covered by individual members. But we could save space in the database
        '    'By storing data as binary using AllProperties and not binding the other fields.
        'theTasks.Columns.Add("AllProperties", GetType(Byte[]))

        ' Parent Task1
        Dim planningTaskid As Guid = Guid.NewGuid()
        ' Assign values for each Task member 
        theTasks.Rows.Add(New [Object]() {planningTaskid, "Planning", DateTime.Now, TimeSpan.FromDays(5), Nothing, 6, Nothing})
        ' Child Task1 of Parent Task1
        theTasks.Rows.Add(New [Object]() {Guid.NewGuid(), "Prepare Budget", DateTime.Now, TimeSpan.FromDays(2), planningTaskid, 6, 100})
        ' Child Task2 of Parent Task1
        theTasks.Rows.Add(New [Object]() {Guid.NewGuid(), "Allocate Teams", DateTime.Now.AddDays(2), TimeSpan.FromDays(60), planningTaskid, 6, Nothing})

        ' Parent Task2
        Dim implementationTaskid As Guid = Guid.NewGuid()
        theTasks.Rows.Add(New [Object]() {implementationTaskid, "Implementation", DateTime.Now.AddDays(6), TimeSpan.FromDays(16), Nothing, 6, Nothing})
        Dim installationTaskid2 As Guid = Guid.NewGuid()


        ' Child Task1 of Parent Task2
        theTasks.Rows.Add(New [Object]() {installationTaskid2, "Installations", DateTime.Now.AddDays(6), TimeSpan.FromDays(2), implementationTaskid, 6, 60})
        ' Child Task2 of Parent Task2
        theTasks.Rows.Add(New [Object]() {Guid.NewGuid(), "Execution", DateTime.Now.AddDays(8), TimeSpan.FromDays(13), implementationTaskid, 6, Nothing})
        ' Parent Task3
        Dim testingTaskid As Guid = Guid.NewGuid()
        theTasks.Rows.Add(New [Object]() {testingTaskid, "Testing", DateTime.Now.AddDays(23), TimeSpan.FromDays(20), Nothing, 6, Nothing})

        ' Child Task1 of Parent Task3
        theTasks.Rows.Add(New [Object]() {Guid.NewGuid(), "TestPhase1", DateTime.Now.AddDays(23), TimeSpan.FromDays(10), testingTaskid, 6,
        20})
        ' Child Task2 of Parent Task3
        theTasks.Rows.Add(New [Object]() {Guid.NewGuid(), "TestPhase2", DateTime.Now.AddDays(36), TimeSpan.FromDays(9), testingTaskid, 6,
        Nothing})

        Return theDataSet
    End Function

End Class
